<template>
  <q-dialog ref="dialog" @hide="$emit('hide')">

    <q-card class="q-dialog-plugin" style="width: 500px; max-width: 85vw;">
      <ValidationObserver v-slot="{ handleSubmit }">
        <q-form ref="FormSubmit" @submit="handleSubmit(submit)">
          <q-card-section
            class="row bg-white q-pt-sm q-pb-none q-mb-none q-card--bordered text-primary"
            style="height: 50px">
            <div class="col-xs-6 text-weight-bolder  q-pt-sm">Changement de mot de passe</div>

            <div class="col-xs-6">
              <q-btn @click="onCancelClick" icon="la la-times"
                     outline class="text-red float-right on-right" flat/>
            </div>
          </q-card-section>
          <q-card-section class="row q-pa-md q-mt-md scroll" style="max-height: 70vh">
            <div class="col-12">
              <p>Vous voulez changer le mot de passe de <strong>{{ user.full_name }}</strong></p>
            </div>
            <div class="col-12">
              <MField
                validation-id="confirmation"
                label="Nouveau mot de passe"
                :main-design="state ==='view' || !canUpdate ? 'borderless' : 'outlined'"
                :readonly="state ==='view' || !canUpdate"
                :hide-bottom-space="state ==='view' || !canUpdate"
                validation-rules="required"
                orientation="vertical"
                :type-input="showNewPassword ? 'text' : 'password'"
                v-model="form.password"
                @m-keyup-enter="onFormSubmit"
              >
                <template v-slot:mAppend>
                  <q-icon
                    :name="showNewPassword ? 'la la-eye' : 'la la-eye-slash'"
                    class="cursor-pointer"
                    color="blue-grey-3"
                    @click="showNewPassword = !showNewPassword"
                  />
                </template>
              </MField>
            </div>
            <div class="col-12">
              <MField
                label="Confirmation"
                :main-design="state ==='view' || !canUpdate ? 'borderless' : 'outlined'"
                :readonly="state ==='view' || !canUpdate"
                :hide-bottom-space="state ==='view' || !canUpdate"
                validation-rules="required|confirmed:confirmation"
                orientation="vertical"
                :type-input="showNewPassword ? 'text' : 'password'"
                v-model="form.passwordConfirmation"
                @m-keyup-enter="onFormSubmit"
              >
                <template v-slot:mAppend>
                  <q-icon
                    :name="showNewPassword ? 'la la-eye' : 'la la-eye-slash'"
                    class="cursor-pointer"
                    color="blue-grey-3"
                    @click="showNewPassword = !showNewPassword"
                  />
                </template>
              </MField>
            </div>
            <div class="col-12">
              <MField
                label="Date d'expiration du nouveau mot de passe (Optionnel)"
                :main-design="state ==='view' || !canUpdate ? 'borderless' : 'outlined'"
                :readonly="state ==='view' || !canUpdate"
                :hide-bottom-space="state ==='view' || !canUpdate"
                orientation="vertical"
                :type-input="'date_time'"
                v-model="form.password_expired_at"
                @m-keyup-enter="onFormSubmit"
              >
              </MField>
            </div>
          </q-card-section>
          <q-card-actions align="right" class=" text-primary">
            <q-btn
              color="primary" dense outline stretch
              label="Enrégistrer" text-color="primary"
              @click="onFormSubmit"/>
          </q-card-actions>
        </q-form>
      </ValidationObserver>
    </q-card>
  </q-dialog>
</template>

<script>
import {mapActions} from 'vuex'
import MSelect from "components/forms/MSelect";
import MField from "components/forms/MField";
import {ValidationObserver} from 'vee-validate';
import moment from 'moment-timezone'
export default {
  name: 'PasswordChangeDialog.vue',

  components: {MField, MSelect, ValidationObserver},

  props: {
    title: {
      type: String,
      default: 'Formulaire'
    },
    state: {
      type: String,
      validator: (value) => ['view', 'create', 'update'].indexOf(value) !== -1
    },
    model: {
      type: Object,
      default: null
    },
    user: {
      type: Object,
      default: null
    },
  },

  data() {
    return {
      showNewPassword: false,
      loading: false,
      form: {
        password: 'p@ssw0rD',
        password_expired_at: null,
        passwordConfirmation: null,
      },
    }
  },

  methods: {
    show() {
      this.$refs.dialog.show()
    },

    hide() {
      this.$refs.dialog.hide()
    },

    onDialogHide() {
      this.$emit('hide')
    },

    async onOKClick() {
      try {
        this.onFormSubmit()
      } catch (e) {
        console.error("err ", e)
      }
    },

    onCancelClick() {
      this.hide()
    },

    onFormSubmit() {
      !this.$refs.FormSubmit.submit()
    },

    submit() {
      if (!this.user)
        return
      if (this.form.password_expired_at) {
        if (moment(this.form.password_expired_at).isBefore(moment.now())){
          this.Motify('warning', 'La date d\'expiration ne peut être inférieure à la date du jour!')
          return;
        }
      }



      this.Loader.show()
      this.changePassword({
        id: this.user.id,
        new_password: this.form.password,
        password_expired_at: this.form.password_expired_at ? new Date(this.form.password_expired_at) : null
      }).then(async response => {
        this.Loader.hide()
        this.Motify('success', `Le mot de passe de ${this.user.full_name} a été changé`)
        this.$emit('ok', response)
        this.hide()
      }).catch(err => {
        this.Loader.hide()
        this.Motify("error", this._getErrorMessage(err), null, 4000)
      })
    },

    ...mapActions({
      changePassword: 'users/forceNewPassword',
    }),
  },

  computed: {
    canCreate() {
      return true
      // return this._can('create_employees')
    },

    canUpdate() {
      return true
      // return this._can('update_employees')
    },
  },

}
</script>
